/////////////////////////////////////////////////////////////////////////////
// Name:        about_dialog.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     19/09/2009 20:58:24
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
#include "wx/imaglist.h"
////@end includes

#include "about_dialog.h"

////@begin XPM images
#include "graphics/vvvPicon32.inc"
////@end XPM images


/*!
 * CAboutDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CAboutDialog, wxDialog )


/*!
 * CAboutDialog event table definition
 */

BEGIN_EVENT_TABLE( CAboutDialog, wxDialog )

////@begin CAboutDialog event table entries
    EVT_BUTTON( wxID_CLOSE, CAboutDialog::OnCloseClick )

////@end CAboutDialog event table entries

END_EVENT_TABLE()


/*!
 * CAboutDialog constructors
 */

CAboutDialog::CAboutDialog()
{
    Init();
}

CAboutDialog::CAboutDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CAboutDialog creator
 */

bool CAboutDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CAboutDialog creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CAboutDialog creation
    return true;
}


/*!
 * CAboutDialog destructor
 */

CAboutDialog::~CAboutDialog()
{
////@begin CAboutDialog destruction
////@end CAboutDialog destruction
}


/*!
 * Member initialisation
 */

void CAboutDialog::Init()
{
////@begin CAboutDialog member initialisation
    m_ProgramNameCtrl = NULL;
////@end CAboutDialog member initialisation
}


/*!
 * Control creation for CAboutDialog
 */

void CAboutDialog::CreateControls()
{    
////@begin CAboutDialog content construction
    CAboutDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer3, 0, wxGROW|wxALL, 5);

    wxStaticBitmap* itemStaticBitmap4 = new wxStaticBitmap( itemDialog1, wxID_STATIC, itemDialog1->GetBitmapResource(wxT("graphics/vvvPicon32.png")), wxDefaultPosition, wxSize(32, 32), 0 );
    itemBoxSizer3->Add(itemStaticBitmap4, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer6 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer3->Add(itemBoxSizer6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_ProgramNameCtrl = new wxStaticText( itemDialog1, wxID_STATIC, _("vvvP x.x"), wxDefaultPosition, wxDefaultSize, 0 );
    m_ProgramNameCtrl->SetFont(wxFont(int(wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetPointSize()*1.8), wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetFamily(), wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetStyle(), wxBOLD, false, wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetFaceName()));
    itemBoxSizer6->Add(m_ProgramNameCtrl, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText8 = new wxStaticText( itemDialog1, wxID_STATIC, _("Virtual Volumes View Photo Edition"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText8->SetFont(wxFont(int(wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetPointSize()*1.3), wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetFamily(), wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetStyle(), wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetWeight(), false, wxSystemSettings::GetFont(wxSYS_DEFAULT_GUI_FONT).GetFaceName()));
    itemBoxSizer6->Add(itemStaticText8, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText9 = new wxStaticText( itemDialog1, wxID_STATIC, _("A program to catalog digital images"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer6->Add(itemStaticText9, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxHyperlinkCtrl* itemHyperlinkCtrl10 = new wxHyperlinkCtrl( itemDialog1, ID_HYPERLINKCTRL_VVVP, _("http://vvvp.sourceforge.net/"), _T("http://vvvp.sourceforge.net/"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer6->Add(itemHyperlinkCtrl10, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxNotebook* itemNotebook11 = new wxNotebook( itemDialog1, ID_NOTEBOOK, wxDefaultPosition, wxDefaultSize, wxBK_DEFAULT );

    wxPanel* itemPanel12 = new wxPanel( itemNotebook11, ID_PANEL_DEVELOPERS, wxDefaultPosition, wxDefaultSize, wxDOUBLE_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer13 = new wxBoxSizer(wxVERTICAL);
    itemPanel12->SetSizer(itemBoxSizer13);

    wxStaticText* itemStaticText14 = new wxStaticText( itemPanel12, wxID_STATIC, _("Main developer: Fulvio Senore."), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer13->Add(itemStaticText14, 0, wxALIGN_LEFT|wxALL, 5);

    itemNotebook11->AddPage(itemPanel12, _("Developers"));

    wxPanel* itemPanel15 = new wxPanel( itemNotebook11, ID_PANEL_ARTISTS, wxDefaultPosition, wxDefaultSize, wxDOUBLE_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer16 = new wxBoxSizer(wxVERTICAL);
    itemPanel15->SetSizer(itemBoxSizer16);

    wxStaticText* itemStaticText17 = new wxStaticText( itemPanel15, wxID_STATIC, _("This program uses icons from the Gnome and Ubuntu projects."), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer16->Add(itemStaticText17, 0, wxALIGN_LEFT|wxALL, 5);

    itemNotebook11->AddPage(itemPanel15, _("Artists"));

    wxPanel* itemPanel18 = new wxPanel( itemNotebook11, ID_PANEL_CREDITS, wxDefaultPosition, wxDefaultSize, wxDOUBLE_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer19 = new wxBoxSizer(wxVERTICAL);
    itemPanel18->SetSizer(itemBoxSizer19);

    wxStaticText* itemStaticText20 = new wxStaticText( itemPanel18, wxID_STATIC, _("vvvP uses the following software:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer19->Add(itemStaticText20, 0, wxALIGN_LEFT|wxALL, 5);

    wxHyperlinkCtrl* itemHyperlinkCtrl21 = new wxHyperlinkCtrl( itemPanel18, ID_HYPERLINKCTRL_WXWIDGETS, _("the wxWidgets framework"), _T("http://www.wxwidgets.org/"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer19->Add(itemHyperlinkCtrl21, 0, wxALIGN_LEFT|wxALL, 5);

    wxHyperlinkCtrl* itemHyperlinkCtrl22 = new wxHyperlinkCtrl( itemPanel18, ID_HYPERLINKCTRL_FIREBIRD, _("the Firebird relational database"), _T("http://www.firebirdsql.org/"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer19->Add(itemHyperlinkCtrl22, 0, wxALIGN_LEFT|wxALL, 5);

    wxHyperlinkCtrl* itemHyperlinkCtrl23 = new wxHyperlinkCtrl( itemPanel18, ID_HYPERLINKCTRL_EXIV2, _("the Exiv2 library"), _T("http://www.exiv2.org/"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer19->Add(itemHyperlinkCtrl23, 0, wxALIGN_LEFT|wxALL, 5);

    wxHyperlinkCtrl* itemHyperlinkCtrl24 = new wxHyperlinkCtrl( itemPanel18, ID_HYPERLINKCTRL_LCMS, _("the Little CMS library"), _T("http://www.littlecms.com/"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer19->Add(itemHyperlinkCtrl24, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText25 = new wxStaticText( itemPanel18, wxID_STATIC, _("The wxThumbnailCtrl control from Julian Smart"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer19->Add(itemStaticText25, 0, wxALIGN_LEFT|wxALL, 5);

    itemNotebook11->AddPage(itemPanel18, _("Credits"));

    wxPanel* itemPanel26 = new wxPanel( itemNotebook11, ID_PANEL, wxDefaultPosition, wxDefaultSize, wxDOUBLE_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer27 = new wxBoxSizer(wxVERTICAL);
    itemPanel26->SetSizer(itemBoxSizer27);

    wxTextCtrl* itemTextCtrl28 = new wxTextCtrl( itemPanel26, ID_TEXTCTRL_LICENSE, _("This is open source software, distributed under the GNU GENERAL PUBLIC LICENSE."), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY|wxDOUBLE_BORDER );
    itemBoxSizer27->Add(itemTextCtrl28, 0, wxGROW|wxALL, 5);

    itemNotebook11->AddPage(itemPanel26, _("License"));

    itemBoxSizer2->Add(itemNotebook11, 0, wxGROW|wxALL, 5);

    wxButton* itemButton29 = new wxButton( itemDialog1, wxID_CLOSE, _("Close"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemButton29, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

////@end CAboutDialog content construction
}


/*!
 * Should we show tooltips?
 */

bool CAboutDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CAboutDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CAboutDialog bitmap retrieval
    wxUnusedVar(name);
    if (name == _T("graphics/vvvPicon32.png"))
    {
        wxMemoryInputStream memStream(vvvPicon32_png, sizeof(vvvPicon32_png));
        wxBitmap bitmap(wxImage(memStream, wxBITMAP_TYPE_ANY, -1), -1);
        return bitmap;
    }
    return wxNullBitmap;
////@end CAboutDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CAboutDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CAboutDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CAboutDialog icon retrieval
}

void CAboutDialog::SetVersion( wxString version )
{
	m_Version = version;
	m_ProgramNameCtrl->SetLabel( wxT("vvvP ") + m_Version );
}



/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_CLOSE
 */

void CAboutDialog::OnCloseClick( wxCommandEvent& event )
{
	EndModal( wxID_CLOSE );
}

