/////////////////////////////////////////////////////////////////////////////
// Name:        chose_folder.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     22/01/2011 11:39:25
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "choose_folder.h"
#include "utils.h"

////@begin XPM images
////@end XPM images


/*!
 * CDlgChoosefolder type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CDlgChoosefolder, wxDialog )


/*!
 * CDlgChoosefolder event table definition
 */

BEGIN_EVENT_TABLE( CDlgChoosefolder, wxDialog )

////@begin CDlgChoosefolder event table entries
    EVT_INIT_DIALOG( CDlgChoosefolder::OnInitDialog )

    EVT_BUTTON( ID_CHOSEFOLDER_BROWSE, CDlgChoosefolder::OnChosefolderBrowseClick )

    EVT_BUTTON( wxID_OK, CDlgChoosefolder::OnOkClick )

////@end CDlgChoosefolder event table entries

END_EVENT_TABLE()


/*!
 * CDlgChoosefolder constructors
 */

CDlgChoosefolder::CDlgChoosefolder()
{
    Init();
}

CDlgChoosefolder::CDlgChoosefolder( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CDlgChosefolder creator
 */

bool CDlgChoosefolder::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CDlgChoosefolder creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CDlgChoosefolder creation

	m_WindowPosition.SetWindow( this );
	m_WindowPosition.RestorePosition();

	return true;
}


/*!
 * CDlgChoosefolder destructor
 */

CDlgChoosefolder::~CDlgChoosefolder()
{
////@begin CDlgChoosefolder destruction
////@end CDlgChoosefolder destruction

	m_WindowPosition.SavePosition();
}


/*!
 * Member initialisation
 */

void CDlgChoosefolder::Init()
{
////@begin CDlgChoosefolder member initialisation
    m_DescriptionCtrl = NULL;
    m_FolderNameCtrl = NULL;
    m_BrowseCtrl = NULL;
////@end CDlgChoosefolder member initialisation
	m_Description = wxEmptyString;
}


/*!
 * Control creation for CDlgChosefolder
 */

void CDlgChoosefolder::CreateControls()
{    
////@begin CDlgChoosefolder content construction
    CDlgChoosefolder* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer2->Add(itemBoxSizer3, 0, wxGROW|wxALL, 5);

    m_DescriptionCtrl = new wxStaticText( itemDialog1, wxID_STATIC, _("Description text"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer3->Add(m_DescriptionCtrl, 0, wxALIGN_LEFT|wxALL, 5);

    itemBoxSizer3->Add(4, 4, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer3->Add(itemBoxSizer6, 0, wxGROW|wxTOP|wxBOTTOM, 5);

    m_FolderNameCtrl = new wxTextCtrl( itemDialog1, ID_CHOSEFOLDER_FOLDER_NAME, wxEmptyString, wxDefaultPosition, wxSize(itemDialog1->ConvertDialogToPixels(wxSize(200, -1)).x, -1), 0 );
    itemBoxSizer6->Add(m_FolderNameCtrl, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_BrowseCtrl = new wxButton( itemDialog1, ID_CHOSEFOLDER_BROWSE, _("..."), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT );
    itemBoxSizer6->Add(m_BrowseCtrl, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStdDialogButtonSizer* itemStdDialogButtonSizer9 = new wxStdDialogButtonSizer;

    itemBoxSizer3->Add(itemStdDialogButtonSizer9, 0, wxALIGN_RIGHT|wxLEFT|wxTOP|wxBOTTOM, 5);
    wxButton* itemButton10 = new wxButton( itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer9->AddButton(itemButton10);

    wxButton* itemButton11 = new wxButton( itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer9->AddButton(itemButton11);

    itemStdDialogButtonSizer9->Realize();

////@end CDlgChoosefolder content construction
}


/*!
 * Should we show tooltips?
 */

bool CDlgChoosefolder::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CDlgChoosefolder::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CDlgChoosefolder bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CDlgChoosefolder bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CDlgChoosefolder::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CDlgChoosefolder icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CDlgChoosefolder icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CHOSEFOLDER_BROWSE
 */

void CDlgChoosefolder::OnChosefolderBrowseClick( wxCommandEvent& event )
{
	wxDirDialog dlg( this, _("Select folder"), m_FolderNameCtrl->GetValue(), wxDD_DEFAULT_STYLE|wxDD_DIR_MUST_EXIST );
	if( dlg.ShowModal() == wxID_OK ) {
        m_FolderNameCtrl->SetValue( dlg.GetPath() );
    }
}


/*!
 * wxEVT_INIT_DIALOG event handler for ID_CDLGCHOSEFOLDER
 */

void CDlgChoosefolder::OnInitDialog( wxInitDialogEvent& event )
{
	wxASSERT( !m_Description.IsEmpty() );

	m_DescriptionCtrl->SetLabel( m_Description );
    GetSizer()->SetSizeHints(this);	// resize the dialog after setting the description
	event.Skip();
}

void CDlgChoosefolder::SetDescription( const wxString& descr )
{
	m_Description = descr;
}

void CDlgChoosefolder::SetPath( const wxString& folderName )
{
	m_FolderNameCtrl->SetValue( folderName );
}

wxString CDlgChoosefolder::GetPath()
{
	wxString path = m_FolderNameCtrl->GetValue();

	return path;
}



/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
 */

void CDlgChoosefolder::OnOkClick( wxCommandEvent& event )
{
	if( !wxDirExists(m_FolderNameCtrl->GetValue()) ) {
		CUtils::MsgErr( _("The folder does not exist") );
		return;
	}
	event.Skip();
}

