/////////////////////////////////////////////////////////////////////////////
// Name:        copy_files_to_location_dialog.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     26/06/2009 11:08:43
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "utils.h"
#include "db_utils.h"
#include "vvvpapp.h"
#include "sqlstrings.h"
#include "long_text_question.h"
#include "fixed_locations.h"
#include "copy_files_to_location_dialog.h"
#include "catalog_images_functions.h"
#include "image_preview.h"
#include "fsdb.h"

#include <wx/dirdlg.h>
#include <wx/dir.h>
#include <wx/filename.h>
#include <wx/filefn.h>

////@begin XPM images
////@end XPM images


/*!
 * CCopyFilesToLocationDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CCopyFilesToLocationDialog, wxDialog )


/*!
 * CCopyFilesToLocationDialog event table definition
 */

BEGIN_EVENT_TABLE( CCopyFilesToLocationDialog, wxDialog )

////@begin CCopyFilesToLocationDialog event table entries
    EVT_BUTTON( ID_DESTINATION_PATH_BROWSE, CCopyFilesToLocationDialog::OnDestinationPathBrowseClick )

#if defined(__WXMSW__)
    EVT_BUTTON( ID_CMD_COPY_FILES, CCopyFilesToLocationDialog::OnCmdCopyFilesClick )
#endif

#if defined(__WXMSW__)
    EVT_BUTTON( wxID_HELP, CCopyFilesToLocationDialog::OnHelpClick )
#endif

#if defined(__WXMAC__) || defined(__WXGTK__)
    EVT_BUTTON( wxID_HELP, CCopyFilesToLocationDialog::OnHelpClick )
#endif

#if defined(__WXMAC__) || defined(__WXGTK__)
    EVT_BUTTON( ID_CMD_COPY_FILES, CCopyFilesToLocationDialog::OnCmdCopyFilesClick )
#endif

////@end CCopyFilesToLocationDialog event table entries

END_EVENT_TABLE()


/*!
 * CCopyFilesToLocationDialog constructors
 */

CCopyFilesToLocationDialog::CCopyFilesToLocationDialog()
{
    Init();
}

CCopyFilesToLocationDialog::CCopyFilesToLocationDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CCopyFilesToLocationDialog creator
 */

bool CCopyFilesToLocationDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CCopyFilesToLocationDialog creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CCopyFilesToLocationDialog creation

	m_WindowPosition.SetWindow( this );
	m_WindowPosition.RestorePosition();

	return true;
}


/*!
 * CCopyFilesToLocationDialog destructor
 */

CCopyFilesToLocationDialog::~CCopyFilesToLocationDialog()
{
////@begin CCopyFilesToLocationDialog destruction
////@end CCopyFilesToLocationDialog destruction

	m_WindowPosition.SavePosition();
}


/*!
 * Member initialisation
 */

void CCopyFilesToLocationDialog::Init()
{
////@begin CCopyFilesToLocationDialog member initialisation
    m_NFilesCtrl = NULL;
    m_DestinationPathCtrl = NULL;
    m_BrowseCtrl = NULL;
    m_ExtractPreviewCtrl = NULL;
    m_ProgressBarCtrl = NULL;
////@end CCopyFilesToLocationDialog member initialisation
}


/*!
 * Control creation for CCopyFilesToLocationDialog
 */

void CCopyFilesToLocationDialog::CreateControls()
{    
////@begin CCopyFilesToLocationDialog content construction
    CCopyFilesToLocationDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxStaticText* itemStaticText3 = new wxStaticText( itemDialog1, wxID_STATIC, _("This command will copy image files to a new location."), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemStaticText3, 0, wxALIGN_LEFT|wxALL, 5);

    m_NFilesCtrl = new wxStaticText( itemDialog1, wxID_STATIC, _("Number of files that will be copied:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(m_NFilesCtrl, 0, wxALIGN_LEFT|wxALL, 5);

    itemBoxSizer2->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText6 = new wxStaticText( itemDialog1, wxID_STATIC, _("Destination path"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemStaticText6, 0, wxALIGN_LEFT|wxALL, 5);

    wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer7, 0, wxGROW|wxTOP, 5);

    m_DestinationPathCtrl = new wxTextCtrl( itemDialog1, ID_DESTINATION_PATH, wxEmptyString, wxDefaultPosition, wxSize(350, -1), 0 );
    itemBoxSizer7->Add(m_DestinationPathCtrl, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_BrowseCtrl = new wxButton( itemDialog1, ID_DESTINATION_PATH_BROWSE, _("..."), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT );
    itemBoxSizer7->Add(m_BrowseCtrl, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_ExtractPreviewCtrl = new wxCheckBox( itemDialog1, ID_CHK_EXTRACT_PREVIEW, _("Extract JPEG preview from RAW images"), wxDefaultPosition, wxDefaultSize, 0 );
    m_ExtractPreviewCtrl->SetValue(false);
    itemBoxSizer2->Add(m_ExtractPreviewCtrl, 0, wxALIGN_LEFT|wxALL, 5);

    m_ProgressBarCtrl = new wxGauge( itemDialog1, ID_GAUGE, 100, wxDefaultPosition, wxSize(-1, 20), wxGA_HORIZONTAL );
    m_ProgressBarCtrl->SetValue(0);
    itemBoxSizer2->Add(m_ProgressBarCtrl, 0, wxGROW|wxALL, 5);

#if defined(__WXMSW__)
    wxBoxSizer* itemBoxSizer12 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer12, 0, wxALIGN_RIGHT|wxTOP|wxBOTTOM, 5);

    wxButton* itemButton13 = new wxButton( itemDialog1, ID_CMD_COPY_FILES, _("Copy"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer12->Add(itemButton13, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton14 = new wxButton( itemDialog1, wxID_CANCEL, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer12->Add(itemButton14, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton15 = new wxButton( itemDialog1, wxID_HELP, _("&Help"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer12->Add(itemButton15, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

#endif

#if defined(__WXMAC__) || defined(__WXGTK__)
    wxBoxSizer* itemBoxSizer16 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer16, 0, wxGROW|wxTOP|wxBOTTOM, 5);

    wxButton* itemButton17 = new wxButton( itemDialog1, wxID_HELP, _("&Help"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer16->Add(itemButton17, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer16->Add(5, 5, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton19 = new wxButton( itemDialog1, wxID_CANCEL, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer16->Add(itemButton19, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton20 = new wxButton( itemDialog1, ID_CMD_COPY_FILES, _("Copy"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer16->Add(itemButton20, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

#endif

////@end CCopyFilesToLocationDialog content construction
}


/*!
 * Should we show tooltips?
 */

bool CCopyFilesToLocationDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CCopyFilesToLocationDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CCopyFilesToLocationDialog bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CCopyFilesToLocationDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CCopyFilesToLocationDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CCopyFilesToLocationDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CCopyFilesToLocationDialog icon retrieval
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_COPY_FILES
 */

void CCopyFilesToLocationDialog::OnCmdCopyFilesClick( wxCommandEvent& WXUNUSED(event) )
{
	bool extractRawPreview = m_ExtractPreviewCtrl->GetValue();

	// destination path
	wxString destinationPath = m_DestinationPathCtrl->GetValue();
	if( destinationPath.empty() ) {
		CUtils::MsgErr( _("You must type or select a destination path") );
		m_DestinationPathCtrl->SetFocus();
		return;
	}
	if( !wxDir::Exists(destinationPath) ) {
		CUtils::MsgErr( _("The destination path does not exist") );
		m_DestinationPathCtrl->SetFocus();
		return;
	}

	std::vector<wxString> filePaths;	// will contain the full paths to the fixed location of each file
	wxString undefinedFixedLocationFilesString = wxEmptyString;	// list of the files from a fixed location of unknown path (not defined for this computer)
	wxString missingFixedLocationFilesString = wxEmptyString;	// list of the files whith no fixed locations
	size_t k;
	{
		wxBusyCursor bc;
		// store the full physical paths in a vector
		for( k = 0; k < fileIDs.size(); k++ ) {
			wxString fullPath;
			CDbUtils::LocationsStatus st = CDbUtils::FixedLocationPathFromID( fileIDs[k], fileNames[k], fullPath );
			if( st == CDbUtils::lsMissingFixedLocation ) {
				// no fixed path defined for this file
				missingFixedLocationFilesString += fileNames[k] + wxT("\n");
			}
			else {
				if( st == CDbUtils::lsUndefinedFixedLocation ) {
					undefinedFixedLocationFilesString += fullPath + wxT("\n");
				}
				else {
					filePaths.push_back( fullPath );
				}
			}
		}
	}
	
	if( missingFixedLocationFilesString != wxEmptyString ) {
		CLongTextQuestion dialog( this, ID_DIALOG_LONG_TEXT_QUESTION, _("Missing fixed locations warning") );
		dialog.SetUpperText( _("Some of the selected files do not have a fixed location defined.\nHere is the list of the files without a fixed location.") );
		dialog.SetMidText( missingFixedLocationFilesString );
		dialog.SetLowerText( _("Click Yes copy the other files, click No to cancel this task.\nDo you want to continue?") );
		dialog.SetHelpPage( wxT("ltq_cpfiles_missing_fixed_location.htm") );
		int r = dialog.ShowModal();
		if( r != wxID_YES )
			return;
	}
	if( undefinedFixedLocationFilesString != wxEmptyString ) {
		CLongTextQuestion dialog( this, ID_DIALOG_LONG_TEXT_QUESTION, _("Unknown fixed locations warning") );
		dialog.SetUpperText( _("Some of the selected files have a fixed location, but this location is not associated with a physical path in this computer.\nYou can use the \"Catalog/Fixed location\" menu to fix this problem.\nHere is the list of the files with unknown fixed locations.") );
		dialog.SetMidText( undefinedFixedLocationFilesString );
		dialog.SetLowerText( _("Click Yes copy the other files, click No to cancel this task.\nDo you want to continue?") );
		dialog.SetHelpPage( wxT("ltq_cpfiles_unknown_fixed_location.htm") );
		int r = dialog.ShowModal();
		if( r != wxID_YES )
			return;
	}

	// check if the files can be found in the fixed location
	std::vector<wxString> filesNotAvailable;
	std::vector<wxString> filesAvailable;
	wxString missingFilesString;
	{
		wxBusyCursor bc;
		for( k = 0; k < filePaths.size(); k++ ) {
			if( !wxFileName::IsFileReadable(filePaths[k]) ) {
				filesNotAvailable.push_back( filePaths[k] );
				missingFilesString += filePaths[k] + wxT("\n");
			}
			else {
				filesAvailable.push_back( filePaths[k] );
			}
		}
	}

	if( filesNotAvailable.size() > 0 ) {
		CLongTextQuestion dialog( this, ID_DIALOG_LONG_TEXT_QUESTION, _("Missing files warning") );
		dialog.SetUpperText( _("Some of the selected files are not available in the fixed location\nor it is not possible to read them.\nHere is the list of the missing files.") );
		dialog.SetMidText( missingFilesString );
		dialog.SetLowerText( _("Click Yes copy the available files, click No to cancel this task.\nDo you want to continue?") );
		dialog.SetHelpPage( wxT("ltq_cpfiles_missing_files.htm") );
		int r = dialog.ShowModal();
		if( r != wxID_YES )
			return;
	}

	// check for possible file overwrite
	wxString overwriteFilesString = wxEmptyString;
	for( k = 0; k < filesAvailable.size(); k++ ) {
		wxString sourcePath = filesAvailable[k];
		// extract filename
		wxFileName fn( sourcePath );
		wxString fileName = fn.GetFullName();
		// create the destination path
		wxString destFilePath = destinationPath + wxFileName::GetPathSeparator() + fileName;
		// if this is a raw file and the user wants to extract the jpeg preview, change the file extension
		wxString ext = fn.GetExt();
		if( extractRawPreview && !CCatalogImagesFunctions::IsHandledImageType(ext) ) {
			// WE SUPPOSE THAT THE PREVIEW WILL BE IN JPEG FORMAT, since the file is created by the exiv2 library
			destFilePath = destFilePath.Left( destFilePath.Len() - ext.Len() ) + wxT("jpg");
			fileName = fileName.Left( fileName.Len() - ext.Len() ) + wxT("jpg");
		}
		if( wxFileExists(destFilePath) )
			overwriteFilesString += fileName + wxT("\n");
	}
	if( overwriteFilesString != wxEmptyString ) {
		CLongTextQuestion dialog( this, ID_DIALOG_LONG_TEXT_QUESTION, _("Files overwrite warning") );
		dialog.SetUpperText( _("Some of the selected files already exist in the destination folder and they will be overwritten.\nHere is the list of the files found in the destination folder.") );
		dialog.SetMidText( overwriteFilesString );
		dialog.SetLowerText( _("Click Yes copy the files, click No to cancel this task.\nDo you want to continue?") );
		dialog.SetHelpPage( wxT("ltq_cpfiles_files_overwrite.htm") );
		int r = dialog.ShowModal();
		if( r != wxID_YES )
			return;
	}

	// now we can copy the files
	wxBusyCursor bc;
	m_ProgressBarCtrl->SetRange( filesAvailable.size() );
	for( k = 0; k < filesAvailable.size(); k++ ) {
		m_ProgressBarCtrl->SetValue( k );
		wxString sourcePath = filesAvailable[k];
		// extract filename
		wxFileName fn( sourcePath );
		wxString fileName = fn.GetFullName();
		// create the destination path
		wxString destFilePath = destinationPath + wxFileName::GetPathSeparator() + fileName;
		CImagePreview::ReturnValue r = CImagePreview::rtNoPreviews;
		if( extractRawPreview && !CCatalogImagesFunctions::IsHandledImageType(fn.GetExt()) ) {
			// extract the prevew image, if any
			r = CImagePreview::ExtractLargestPreview( sourcePath, destinationPath );
		}
		if( r != CImagePreview::rtOk ) {
			// copy the file
			wxCopyFile( sourcePath, destFilePath, true );
		}
	}

	EndModal( wxID_OK );
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DESTINATION_PATH_BROWSE
 */

void CCopyFilesToLocationDialog::OnDestinationPathBrowseClick( wxCommandEvent& WXUNUSED(event) )
{
	wxDirDialog dlg( this, _("Select the destination path"), m_DestinationPathCtrl->GetValue(), wxDD_DEFAULT_STYLE|wxDD_DIR_MUST_EXIST );
	if( dlg.ShowModal() == wxID_OK ) {
		wxString path = dlg.GetPath();
		m_DestinationPathCtrl->SetValue( path );
	}
}

void CCopyFilesToLocationDialog::SetFilesData( std::vector<int> &fileIDs, std::vector<wxString> &fileNames )
{
	this->fileIDs = fileIDs;
	this->fileNames = fileNames;

	wxString txtNFiles = m_NFilesCtrl->GetLabel();
	txtNFiles += wxT(" ") + CUtils::long2string( fileIDs.size() );
	m_NFilesCtrl->SetLabel( txtNFiles );

	// check if the list contains possible raw files 
	//(since there are many possible extension we simply check if some extensions are not jpg or similar)
	bool possibleRawFiles = false;
	for( size_t k = 0; k < fileNames.size(); k++ ) {
		wxFileName fn( fileNames[k] );
		wxString ext = fn.GetExt();
		if( !CCatalogImagesFunctions::IsHandledImageType(ext) ) {
			possibleRawFiles = true;
			break;
		}
	}
	// if there are no raw files make invisible the "extract preview" checkbox
	if( !possibleRawFiles ) {
		m_ExtractPreviewCtrl->Show( false );
	}
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
 */

void CCopyFilesToLocationDialog::OnHelpClick( wxCommandEvent& WXUNUSED(event) )
{
	wxGetApp().GetHelpController()->DisplaySection( wxT("copy_selected_files.htm") );
}

wxString CCopyFilesToLocationDialog::GetPath() const
{
	return m_DestinationPathCtrl->GetValue();
}

void CCopyFilesToLocationDialog::SetPath( const wxString &path )
{
	m_DestinationPathCtrl->SetValue( path );
}

bool CCopyFilesToLocationDialog::GetExtractJPEGPrevewFromRAW() const
{
	return m_ExtractPreviewCtrl->GetValue();
}

void CCopyFilesToLocationDialog::SetExtractJPEGPrevewFromRAW( const bool setting )
{
	m_ExtractPreviewCtrl->SetValue( setting );
}

