/////////////////////////////////////////////////////////////////////////////
// Name:        dlg_external_programs.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     28/11/2010 18:33:02
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
#include "wx/imaglist.h"
////@end includes

#include "dlg_external_programs.h"
#include "external_programs.h"
#include "vvvpapp.h"

////@begin XPM images
////@end XPM images


/*!
 * CExternalProgramsDlg type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CExternalProgramsDlg, wxDialog )


/*!
 * CExternalProgramsDlg event table definition
 */

BEGIN_EVENT_TABLE( CExternalProgramsDlg, wxDialog )

////@begin CExternalProgramsDlg event table entries
    EVT_SIZE( CExternalProgramsDlg::OnSize )

    EVT_BUTTON( ID_BUTTON_ADD, CExternalProgramsDlg::OnButtonAddClick )

    EVT_BUTTON( ID_BUTTON_EDIT, CExternalProgramsDlg::OnButtonEditClick )

    EVT_BUTTON( ID_BUTTON_DELETE, CExternalProgramsDlg::OnButtonDeleteClick )

    EVT_BUTTON( wxID_HELP, CExternalProgramsDlg::OnHelpClick )

    EVT_BUTTON( ID_DLG_OK, CExternalProgramsDlg::OnDlgOkClick )

    EVT_BUTTON( ID_DLG_CANCEL, CExternalProgramsDlg::OnDlgCancelClick )

////@end CExternalProgramsDlg event table entries

END_EVENT_TABLE()


/*!
 * CExternalProgramsDlg constructors
 */

CExternalProgramsDlg::CExternalProgramsDlg()
{
    Init();
}

CExternalProgramsDlg::CExternalProgramsDlg( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CExternalProgramsDlg creator
 */

bool CExternalProgramsDlg::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CExternalProgramsDlg creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CExternalProgramsDlg creation

	CreateLCHeaders();
	FillListControl();
	HideShowLowerPart( false );
	m_EditStatus = esNoEdit;

	m_WindowPosition.SetWindow( this );
	m_WindowPosition.RestorePosition();

	ResizeLCColumns();

	return true;
}


/*!
 * CExternalProgramsDlg destructor
 */

CExternalProgramsDlg::~CExternalProgramsDlg()
{
////@begin CExternalProgramsDlg destruction
////@end CExternalProgramsDlg destruction
	m_WindowPosition.SavePosition();
}


/*!
 * Member initialisation
 */

void CExternalProgramsDlg::Init()
{
////@begin CExternalProgramsDlg member initialisation
    m_ListCtrl = NULL;
    m_AddButton = NULL;
    m_EditButton = NULL;
    m_DeleteButton = NULL;
    m_CloseButton = NULL;
    m_CommandLineLabel = NULL;
    m_CommandLineCtrl = NULL;
    m_DescriptionLabel = NULL;
    m_DescriptionCtrl = NULL;
    m_UseCopyCtrl = NULL;
    m_OkButton = NULL;
    m_CancelButton = NULL;
////@end CExternalProgramsDlg member initialisation
}


/*!
 * Control creation for CExternalProgramsDlg
 */

void CExternalProgramsDlg::CreateControls()
{    
////@begin CExternalProgramsDlg content construction
    CExternalProgramsDlg* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    m_ListCtrl = new wxListCtrl( itemDialog1, ID_LIST_PROGRAMS, wxDefaultPosition, wxSize(100, 100), wxLC_REPORT|wxLC_NO_SORT_HEADER );
    itemBoxSizer2->Add(m_ListCtrl, 1, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer4, 0, wxGROW|wxALL, 5);

    m_AddButton = new wxButton( itemDialog1, ID_BUTTON_ADD, _("Add"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(m_AddButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_EditButton = new wxButton( itemDialog1, ID_BUTTON_EDIT, _("Edit"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(m_EditButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_DeleteButton = new wxButton( itemDialog1, ID_BUTTON_DELETE, _("Delete"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(m_DeleteButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton8 = new wxButton( itemDialog1, wxID_HELP, _("&Help"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemButton8, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer4->Add(5, 5, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_CloseButton = new wxButton( itemDialog1, wxID_CLOSE, _("&Close"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(m_CloseButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticLine* itemStaticLine11 = new wxStaticLine( itemDialog1, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
    itemBoxSizer2->Add(itemStaticLine11, 0, wxGROW|wxALL, 5);

    wxFlexGridSizer* itemFlexGridSizer12 = new wxFlexGridSizer(0, 2, 0, 0);
    itemBoxSizer2->Add(itemFlexGridSizer12, 0, wxGROW|wxALL, 5);

    m_CommandLineLabel = new wxStaticText( itemDialog1, wxID_STATIC, _("Command line"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer12->Add(m_CommandLineLabel, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_CommandLineCtrl = new wxTextCtrl( itemDialog1, ID_COMMAND_NAME, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer12->Add(m_CommandLineCtrl, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_DescriptionLabel = new wxStaticText( itemDialog1, wxID_STATIC, _("Description"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer12->Add(m_DescriptionLabel, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_DescriptionCtrl = new wxTextCtrl( itemDialog1, ID_DESCRIPTION, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer12->Add(m_DescriptionCtrl, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemFlexGridSizer12->AddGrowableCol(1);

    wxBoxSizer* itemBoxSizer17 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer17, 0, wxALIGN_LEFT|wxALL, 5);

    m_UseCopyCtrl = new wxCheckBox( itemDialog1, ID_CHECKBOX, _("Use a copy of the file"), wxDefaultPosition, wxDefaultSize, 0 );
    m_UseCopyCtrl->SetValue(false);
    itemBoxSizer17->Add(m_UseCopyCtrl, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxBoxSizer* itemBoxSizer19 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer19, 0, wxALIGN_RIGHT|wxALL, 5);

    m_OkButton = new wxButton( itemDialog1, ID_DLG_OK, _("OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer19->Add(m_OkButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_CancelButton = new wxButton( itemDialog1, ID_DLG_CANCEL, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer19->Add(m_CancelButton, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end CExternalProgramsDlg content construction

	SetAffirmativeId( wxID_CLOSE );
}


/*!
 * Should we show tooltips?
 */

bool CExternalProgramsDlg::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CExternalProgramsDlg::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CExternalProgramsDlg bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CExternalProgramsDlg bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CExternalProgramsDlg::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CExternalProgramsDlg icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CExternalProgramsDlg icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_ADD
 */

void CExternalProgramsDlg::OnButtonAddClick( wxCommandEvent& event )
{
	wxASSERT( m_EditStatus == esNoEdit );

	HideShowLowerPart( true );
	m_CommandLineCtrl->SetFocus();
	m_EditStatus = esAppend;
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_EDIT
 */

void CExternalProgramsDlg::OnButtonEditClick( wxCommandEvent& event )
{
	wxASSERT( m_EditStatus == esNoEdit );

	long i = GetLCSelectedItemIndex();
	if( i < 0 ) return;

	HideShowLowerPart( true );
	m_CommandLineCtrl->SetFocus();
	m_EditStatus = esEdit;

	CExternalPrograms& ep = m_data.m_ExternalPrograms;
	m_CommandLineCtrl->SetValue( ep[i].GetCommandLine() );
	m_DescriptionCtrl->SetValue( ep[i].GetDescription() );
	m_UseCopyCtrl->SetValue( ep[i].GetMakeCopy() );
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_DELETE
 */

void CExternalProgramsDlg::OnButtonDeleteClick( wxCommandEvent& event )
{
	wxASSERT( m_EditStatus == esNoEdit );

	long i = GetLCSelectedItemIndex();
	if( i < 0 ) return;

	wxString msg = wxT("This command will delete the external program definition from the list shown in this window.");
	msg += wxT("\n\n");
	msg += wxT("Do you really want to delete the selected external program?");

	if( !CUtils::MsgAskNo(msg) ) return;

	CExternalPrograms& ep = m_data.m_ExternalPrograms;
	ep.Remove( i );
	FillListControl();
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
 */

void CExternalProgramsDlg::OnHelpClick( wxCommandEvent& event )
{
	wxGetApp().GetHelpController()->DisplaySection( wxT("external_programs.htm") );
}

void CExternalProgramsDlg::HideShowLowerPart( bool visible ) {

	if( !visible ) {
		m_CommandLineCtrl->SetValue( wxEmptyString );
		m_DescriptionCtrl->SetValue( wxEmptyString );
	}
	m_CommandLineLabel->Enable( visible );
	m_CommandLineCtrl->Enable( visible );
	m_DescriptionLabel->Enable( visible );
	m_DescriptionCtrl->Enable( visible );
	m_UseCopyCtrl->Enable( visible );
	m_OkButton->Enable( visible );
	m_CancelButton->Enable( visible );

	m_AddButton->Enable( !visible );
	m_EditButton->Enable( !visible );
	m_DeleteButton->Enable( !visible );
	m_CloseButton->Enable( !visible );
	m_ListCtrl->Enable( !visible );

}





/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DLG_CANCEL
 */

void CExternalProgramsDlg::OnDlgCancelClick( wxCommandEvent& event )
{
	wxASSERT( m_EditStatus == esEdit || m_EditStatus == esAppend );

	HideShowLowerPart( false );
	m_EditStatus = esNoEdit;
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DLG_OK
 */

void CExternalProgramsDlg::OnDlgOkClick( wxCommandEvent& event )
{
	int index = -1;

	wxASSERT( m_EditStatus == esEdit || m_EditStatus == esAppend );

	CExternalPrograms& ep = m_data.m_ExternalPrograms;

	// check data
	wxString commandLine = m_CommandLineCtrl->GetValue();
	wxString description = m_DescriptionCtrl->GetValue();
	bool makeCopy = m_UseCopyCtrl->GetValue();
	index = GetLCSelectedItemIndex();
	CExternalPrograms::Error err;
	if( m_EditStatus == esAppend ) {
		err = ep.Append( commandLine, description, makeCopy );
	}
	else {
		err = ep.Edit( commandLine, description, makeCopy, index );
	}
	if( err != CExternalPrograms::eNoError ) {
		wxString msg;
		switch( err ) {
			case CExternalPrograms::eMissingCommandLine:
				msg = _("The command line is missing");
				break;
			case CExternalPrograms::eMissingDescription:
				msg = _("The description is missing");
				break;
			case CExternalPrograms::eDuplicateCommandLine:
				msg = _("The command line is already present in the list");
				break;
			case CExternalPrograms::eDuplicateDescription:
				msg = _("The description is already present in the list");
				break;
		}
		CUtils::MsgErr( msg );
		return;
	}

	// write data to the list control
	FillListControl();
//	ep.Save();

	HideShowLowerPart( false );
	m_EditStatus = esNoEdit;
}

long CExternalProgramsDlg::GetLCSelectedItemIndex() {

	int index = -1;
	index = m_ListCtrl->GetNextItem( index, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
	return index;
}

void CExternalProgramsDlg::CreateLCHeaders() {

	wxListItem itemCol;
	int i = 0;

	itemCol.SetText( _("Command line") );
	itemCol.SetAlign( wxLIST_FORMAT_LEFT );
	m_ListCtrl->InsertColumn( i++, itemCol );

	itemCol.SetText( _("Description") );
	itemCol.SetAlign( wxLIST_FORMAT_LEFT );
	m_ListCtrl->InsertColumn( i++, itemCol );

	itemCol.SetText( _("Copy") );
	itemCol.SetAlign( wxLIST_FORMAT_LEFT );
	m_ListCtrl->InsertColumn( i++, itemCol );
}



/*!
 * wxEVT_SIZE event handler for ID_CEXTERNALPROGRAMSDLG
 */

void CExternalProgramsDlg::OnSize( wxSizeEvent& event )
{
	event.Skip();
	ResizeLCColumns();
}

void CExternalProgramsDlg::ResizeLCColumns() {
	int x, y;
	int w0, w1, w2;

    if( m_ListCtrl == NULL ) return;
    
    m_ListCtrl->GetClientSize( &x, &y );
	w2 = x / 7;
	w0 = x * 3 / 7;
	w1 = x - w0 - w2;
	m_ListCtrl->SetColumnWidth( 0, w0 );
	m_ListCtrl->SetColumnWidth( 1, w1 );
	m_ListCtrl->SetColumnWidth( 2, w2 );
}

void CExternalProgramsDlg::FillListControl() {

	m_ListCtrl->DeleteAllItems();
	CExternalPrograms& ep = m_data.m_ExternalPrograms;
	for( size_t k = 0; k < ep.size(); k++ ) {
    	int i = m_ListCtrl->InsertItem( 0, "" );

	    // this code is used to set the item's mask
	    wxListItem item;
	    item.SetId( i );
	    m_ListCtrl->GetItem( item );
	    item.SetMask( wxLIST_MASK_STATE|wxLIST_MASK_TEXT|wxLIST_MASK_DATA );
	    m_ListCtrl->SetItem( item );
        
		int col = 0;
		int epIndex = ep.size() - k - 1;	// items are inserted at the top of the list
		m_ListCtrl->SetItem( i, col, ep[epIndex].GetCommandLine() );
		col++;
		m_ListCtrl->SetItem( i, col, ep[epIndex].GetDescription() );
		col++;
		wxString yn = ep[epIndex].GetMakeCopy() ? _("Yes") : _("No");
		m_ListCtrl->SetItem( i, col, yn );
		col++;
	}
}

