/////////////////////////////////////////////////////////////////////////////
// Name:        dlg_external_programs.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     28/11/2010 18:33:02
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _DLG_EXTERNAL_PROGRAMS_H_
#define _DLG_EXTERNAL_PROGRAMS_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/listctrl.h"
#include "wx/statline.h"
////@end includes

#include "window_position.h"
#include "app_settings.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxListCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CEXTERNALPROGRAMSDLG 10140
#define ID_LIST_PROGRAMS 10141
#define ID_BUTTON_ADD 10142
#define ID_BUTTON_EDIT 10143
#define ID_BUTTON_DELETE 10144
#define ID_COMMAND_NAME 10145
#define ID_DESCRIPTION 10146
#define ID_CHECKBOX 10147
#define ID_DLG_OK 10044
#define ID_DLG_CANCEL 10045
#define SYMBOL_CEXTERNALPROGRAMSDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CEXTERNALPROGRAMSDLG_TITLE _("External programs")
#define SYMBOL_CEXTERNALPROGRAMSDLG_IDNAME ID_CEXTERNALPROGRAMSDLG
#define SYMBOL_CEXTERNALPROGRAMSDLG_SIZE wxSize(400, 300)
#define SYMBOL_CEXTERNALPROGRAMSDLG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CExternalProgramsDlg class declaration
 */

class CExternalProgramsDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CExternalProgramsDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CExternalProgramsDlg();
    CExternalProgramsDlg( wxWindow* parent, wxWindowID id = SYMBOL_CEXTERNALPROGRAMSDLG_IDNAME, const wxString& caption = SYMBOL_CEXTERNALPROGRAMSDLG_TITLE, const wxPoint& pos = SYMBOL_CEXTERNALPROGRAMSDLG_POSITION, const wxSize& size = SYMBOL_CEXTERNALPROGRAMSDLG_SIZE, long style = SYMBOL_CEXTERNALPROGRAMSDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CEXTERNALPROGRAMSDLG_IDNAME, const wxString& caption = SYMBOL_CEXTERNALPROGRAMSDLG_TITLE, const wxPoint& pos = SYMBOL_CEXTERNALPROGRAMSDLG_POSITION, const wxSize& size = SYMBOL_CEXTERNALPROGRAMSDLG_SIZE, long style = SYMBOL_CEXTERNALPROGRAMSDLG_STYLE );

    /// Destructor
    ~CExternalProgramsDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CExternalProgramsDlg event handler declarations

    /// wxEVT_SIZE event handler for ID_CEXTERNALPROGRAMSDLG
    void OnSize( wxSizeEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_ADD
    void OnButtonAddClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_EDIT
    void OnButtonEditClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_DELETE
    void OnButtonDeleteClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
    void OnHelpClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DLG_OK
    void OnDlgOkClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DLG_CANCEL
    void OnDlgCancelClick( wxCommandEvent& event );

////@end CExternalProgramsDlg event handler declarations

////@begin CExternalProgramsDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CExternalProgramsDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

    /// Data access
    CAppSettings& GetData() { return m_data; }
    const CAppSettings& GetData() const { return m_data; }
    void SetData(const CAppSettings& data) { m_data = data; FillListControl(); }

////@begin CExternalProgramsDlg member variables
    wxListCtrl* m_ListCtrl;
    wxButton* m_AddButton;
    wxButton* m_EditButton;
    wxButton* m_DeleteButton;
    wxButton* m_CloseButton;
    wxStaticText* m_CommandLineLabel;
    wxTextCtrl* m_CommandLineCtrl;
    wxStaticText* m_DescriptionLabel;
    wxTextCtrl* m_DescriptionCtrl;
    wxCheckBox* m_UseCopyCtrl;
    wxButton* m_OkButton;
    wxButton* m_CancelButton;
////@end CExternalProgramsDlg member variables

private:

	CWindowPosition m_WindowPosition;

	// hide (visible=false) or show (visible=true) the controls in the lower part of the dialog
	void HideShowLowerPart( bool visible );

	// create the list control's headers
	void CreateLCHeaders();

	// resize the list control's columns to fit the control's width
	void ResizeLCColumns();

	// fill the list control with the current fixed locations
	void FillListControl();

	// current status of the lower part of the window
	enum EditStatus {
		esNoEdit,	/* controls are not enabled */
		esAppend,	/* the user has pressed the Append button */
		esEdit		/* the user has pressed the Edit button */
	};
	EditStatus m_EditStatus;

	// return the 0-based id of the selected item, -1 if no item is selected
	long GetLCSelectedItemIndex();

    CAppSettings m_data;

};

#endif
    // _DLG_EXTERNAL_PROGRAMS_H_
