/////////////////////////////////////////////////////////////////////////////
// Name:        long_text_info.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     22/11/2009 22:03:21
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

/*
this is a dialog that can be used to show an information message containg a (possibly long) list of items.
It is divided in two parts:

- The top part is a static text that shows info that describe the list. It is set by SetUpperText()
- The bottom part is a read/only text box that can show a high number of lines. It is possibile to select the
lines and copy them to the clipboard. This text is set by SetLongText()

The dialog shows an OK button to close it

*/


#ifndef _LONG_TEXT_INFO_H_
#define _LONG_TEXT_INFO_H_


/*!
 * Includes
 */

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxBoxSizer;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_DIALOG_LONG_TEXT_INFO 10136
#define ID_LONG_TEXT 10137
#define SYMBOL_CLONGTEXTINFO_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CLONGTEXTINFO_TITLE _("Long text info")
#define SYMBOL_CLONGTEXTINFO_IDNAME ID_DIALOG_LONG_TEXT_INFO
#define SYMBOL_CLONGTEXTINFO_SIZE wxSize(400, 300)
#define SYMBOL_CLONGTEXTINFO_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CLongTextInfo class declaration
 */

class CLongTextInfo: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CLongTextInfo )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CLongTextInfo();
    CLongTextInfo( wxWindow* parent, wxWindowID id = SYMBOL_CLONGTEXTINFO_IDNAME, const wxString& caption = SYMBOL_CLONGTEXTINFO_TITLE, const wxPoint& pos = SYMBOL_CLONGTEXTINFO_POSITION, const wxSize& size = SYMBOL_CLONGTEXTINFO_SIZE, long style = SYMBOL_CLONGTEXTINFO_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CLONGTEXTINFO_IDNAME, const wxString& caption = SYMBOL_CLONGTEXTINFO_TITLE, const wxPoint& pos = SYMBOL_CLONGTEXTINFO_POSITION, const wxSize& size = SYMBOL_CLONGTEXTINFO_SIZE, long style = SYMBOL_CLONGTEXTINFO_STYLE );

    /// Destructor
    ~CLongTextInfo();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CLongTextInfo event handler declarations

////@end CLongTextInfo event handler declarations

////@begin CLongTextInfo member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CLongTextInfo member function declarations

	void SetUpperText( wxString msg ) { m_UpperTextCtrl->SetLabel( msg ); AdaptSize(); }
	void SetLongText( wxString msg ) { m_LongTextCtrl->SetValue( msg ); }

	/// Should we show tooltips?
    static bool ShowToolTips();

////@begin CLongTextInfo member variables
    wxBoxSizer* m_MainSizer;
    wxStaticText* m_UpperTextCtrl;
    wxTextCtrl* m_LongTextCtrl;
////@end CLongTextInfo member variables

private:

	// resize the dialog to fit to control that have changed size
	void AdaptSize();
};

#endif
    // _LONG_TEXT_INFO_H_
