/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2009, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        resize_thumbnails_dialog.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     19/10/2009 08:51:21
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "resize_thumbnails_dialog.h"
#include "vvvpapp.h"

////@begin XPM images
////@end XPM images


/*!
 * CDialogResizeThumbnails type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CDialogResizeThumbnails, wxDialog )


/*!
 * CDialogResizeThumbnails event table definition
 */

BEGIN_EVENT_TABLE( CDialogResizeThumbnails, wxDialog )

////@begin CDialogResizeThumbnails event table entries
    EVT_BUTTON( wxID_HELP, CDialogResizeThumbnails::OnHelpClick )

////@end CDialogResizeThumbnails event table entries

END_EVENT_TABLE()


/*!
 * CDialogResizeThumbnails constructors
 */

CDialogResizeThumbnails::CDialogResizeThumbnails()
{
    Init();
}

CDialogResizeThumbnails::CDialogResizeThumbnails( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CDialogResizeThumbnails creator
 */

bool CDialogResizeThumbnails::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CDialogResizeThumbnails creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CDialogResizeThumbnails creation
    return true;
}


/*!
 * CDialogResizeThumbnails destructor
 */

CDialogResizeThumbnails::~CDialogResizeThumbnails()
{
////@begin CDialogResizeThumbnails destruction
////@end CDialogResizeThumbnails destruction
}


/*!
 * Member initialisation
 */

void CDialogResizeThumbnails::Init()
{
////@begin CDialogResizeThumbnails member initialisation
    m_ThumbnailsSizeCtrl = NULL;
    m_HelpButton = NULL;
////@end CDialogResizeThumbnails member initialisation
}


/*!
 * Control creation for CDialogResizeThumbnails
 */

void CDialogResizeThumbnails::CreateControls()
{    
////@begin CDialogResizeThumbnails content construction
    CDialogResizeThumbnails* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxStaticText* itemStaticText3 = new wxStaticText( itemDialog1, wxID_STATIC, _("This command will resize the thumbnails of the selected images."), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemStaticText3, 0, wxALIGN_LEFT|wxALL, 5);

    itemBoxSizer2->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer5, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText6 = new wxStaticText( itemDialog1, wxID_STATIC, _("Enter the new thumbnails size:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer5->Add(itemStaticText6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_ThumbnailsSizeCtrl = new wxSpinCtrl( itemDialog1, ID_RESIZE_THUMBNAILS_SIZE, _T("0"), wxDefaultPosition, wxSize(60, -1), wxSP_ARROW_KEYS, 0, 5000, 0 );
    itemBoxSizer5->Add(m_ThumbnailsSizeCtrl, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer2->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStdDialogButtonSizer* itemStdDialogButtonSizer9 = new wxStdDialogButtonSizer;

    itemBoxSizer2->Add(itemStdDialogButtonSizer9, 0, wxGROW|wxALL, 10);
    wxButton* itemButton10 = new wxButton( itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer9->AddButton(itemButton10);

    wxButton* itemButton11 = new wxButton( itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer9->AddButton(itemButton11);

    m_HelpButton = new wxButton( itemDialog1, wxID_HELP, _("&Help"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer9->AddButton(m_HelpButton);

    itemStdDialogButtonSizer9->Realize();

////@end CDialogResizeThumbnails content construction
}


/*!
 * Should we show tooltips?
 */

bool CDialogResizeThumbnails::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CDialogResizeThumbnails::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CDialogResizeThumbnails bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CDialogResizeThumbnails bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CDialogResizeThumbnails::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CDialogResizeThumbnails icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CDialogResizeThumbnails icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
 */

void CDialogResizeThumbnails::OnHelpClick( wxCommandEvent& event )
{
	wxGetApp().GetHelpController()->DisplaySection( wxT("resize_thumbnails.htm") );
}

