/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sha1wrapper.h"
#include "sha1.h"

CSHA1Wrapper::CSHA1Wrapper(void)
{
}

CSHA1Wrapper::~CSHA1Wrapper(void)
{
}

wxString CSHA1Wrapper::ComputeHash( void *buf, int size ) {

	const int chunkSize = 10000;
	int digestedBytes = 0;
	int nBytes;

    sha1_context ctx;
	uchar digest[20];
	char hex_output[20*2 + 1];

	sha1_starts( &ctx );

	unsigned char *cp = (unsigned char *) buf;
	
	while( digestedBytes < size ) {
		nBytes = chunkSize;
		if( (digestedBytes + nBytes) > size )
			nBytes = size - digestedBytes;

        sha1_update( &ctx, cp, nBytes );
		
		cp += nBytes;
		digestedBytes += nBytes;
	}
    sha1_finish( &ctx, digest );

	for ( int i = 0; i < 20; i++ )
	    sprintf( hex_output + i * 2, "%02X", digest[i] );

	return wxString( hex_output, wxConvISO8859_1 );

}

