/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* 
   this class implements a class that computes the MD5 hash of a memory buffer

   it is a wrapper tha calls the (about) standard files available from the internet
*/

#ifndef __SHA1_WRAPPER_H__
#define __SHA1_WRAPPER_H__

#include <wx/string.h>

class CSHA1Wrapper
{
public:
	CSHA1Wrapper(void);
	~CSHA1Wrapper(void);

	/// return the MD5 hash of the buffer of a given size in bytes
	static wxString ComputeHash( void *buf, int size );

};


#endif

