/////////////////////////////////////////////////////////////////////////////
// Name:        timeline_panel.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     25/05/2012 08:25:57
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
#include "wx/imaglist.h"
////@end includes

#include "timeline_panel.h"
#include "sqlstrings.h"
#include "mainframe.h"
#include "vvvpapp.h"

////@begin XPM images
////@end XPM images


/*!
 * CTimelinePanel type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CTimelinePanel, wxPanel )


/*!
 * CTimelinePanel event table definition
 */

BEGIN_EVENT_TABLE( CTimelinePanel, wxPanel )

////@begin CTimelinePanel event table entries
    EVT_SET_FOCUS( CTimelinePanel::OnSetFocus )

    EVT_BUTTON( ID_BUTTON_TIMELINE_SEARCH, CTimelinePanel::OnButtonTimelineSearchClick )

    EVT_LIST_ITEM_SELECTED( wxID_ANY, CTimelinePanel::OnAnySelected )

////@end CTimelinePanel event table entries

END_EVENT_TABLE()


/*!
 * CTimelinePanel constructors
 */

CTimelinePanel::CTimelinePanel()
{
    Init();
}

CTimelinePanel::CTimelinePanel(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style)
{
    Init();
    Create(parent, id, pos, size, style);
}


/*!
 * CTimelinePanel creator
 */

bool CTimelinePanel::Create(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style)
{
////@begin CTimelinePanel creation
    wxPanel::Create(parent, id, pos, size, style);
    CreateControls();
    if (GetSizer())
        GetSizer()->Fit(this);
////@end CTimelinePanel creation
    return true;
}


/*!
 * CTimelinePanel destructor
 */

CTimelinePanel::~CTimelinePanel()
{
////@begin CTimelinePanel destruction
////@end CTimelinePanel destruction

	CAppSettings& as = wxGetApp().GetAppSettings();
	as.m_TimelineStartDate = m_StartDate->GetValueDT();
	as.m_TimelineEndDate = m_EndDate->GetValueDT();
    as.m_TimelineThreshold = m_ThresholdCtrl->GetValue();
}


/*!
 * Member initialisation
 */

void CTimelinePanel::Init()
{
////@begin CTimelinePanel member initialisation
    m_StartDate = NULL;
    m_EndDate = NULL;
    m_ThresholdCtrl = NULL;
    m_SearchButton = NULL;
    m_ListCtrl = NULL;
////@end CTimelinePanel member initialisation
}


/*!
 * Control creation for CTimelinePanel
 */

void CTimelinePanel::CreateControls()
{    
////@begin CTimelinePanel content construction
    CTimelinePanel* itemPanel1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemPanel1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer2->Add(itemBoxSizer3, 1, wxALIGN_LEFT|wxALL, 5);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer3->Add(itemBoxSizer4, 0, wxALIGN_LEFT, 5);

    m_StartDate = new fsDatePickerCtrl( itemPanel1, wxID_ANY, wxDateTime(), wxDefaultPosition, wxDefaultSize, wxDP_DROPDOWN|wxDP_ALLOWNONE );
    itemBoxSizer4->Add(m_StartDate, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText6 = new wxStaticText( itemPanel1, wxID_STATIC, _("(Start date)"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 3);

    itemBoxSizer4->Add(5, 5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer3->Add(itemBoxSizer8, 0, wxALIGN_LEFT, 5);

    m_EndDate = new fsDatePickerCtrl( itemPanel1, wxID_ANY, wxDateTime(), wxDefaultPosition, wxDefaultSize, wxDP_DROPDOWN|wxDP_ALLOWNONE );
    itemBoxSizer8->Add(m_EndDate, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText10 = new wxStaticText( itemPanel1, wxID_STATIC, _("(End date)"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer8->Add(itemStaticText10, 0, wxALIGN_CENTER_VERTICAL|wxALL, 3);

    wxBoxSizer* itemBoxSizer11 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer3->Add(itemBoxSizer11, 0, wxALIGN_LEFT, 5);

    m_ThresholdCtrl = new wxSpinCtrl( itemPanel1, wxID_ANY, _T("0"), wxDefaultPosition, wxSize(60, -1), wxSP_ARROW_KEYS, 0, 100, 0 );
    itemBoxSizer11->Add(m_ThresholdCtrl, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText13 = new wxStaticText( itemPanel1, wxID_STATIC, _("(Threshold)"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer11->Add(itemStaticText13, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    m_SearchButton = new wxButton( itemPanel1, ID_BUTTON_TIMELINE_SEARCH, _("Search"), wxDefaultPosition, wxDefaultSize, 0 );
    m_SearchButton->SetDefault();
    itemBoxSizer3->Add(m_SearchButton, 0, wxALIGN_LEFT|wxALL, 3);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    m_ListCtrl = new wxListCtrl( itemPanel1, wxID_ANY, wxDefaultPosition, wxSize(100, 100), wxLC_REPORT|wxLC_NO_SORT_HEADER );
    itemBoxSizer3->Add(m_ListCtrl, 1, wxGROW|wxALL, 5);

////@end CTimelinePanel content construction

	CAppSettings& as = wxGetApp().GetAppSettings();
	m_StartDate->SetValueDT( as.m_TimelineStartDate );
	m_EndDate->SetValueDT( as.m_TimelineEndDate );
    m_ThresholdCtrl->SetValue( as.m_TimelineThreshold );

    CreateLCHeaders();
}


/*!
 * wxEVT_SET_FOCUS event handler for ID_TIMELINE_PANEL
 */

void CTimelinePanel::OnSetFocus( wxFocusEvent& event )
{
////@begin wxEVT_SET_FOCUS event handler for ID_TIMELINE_PANEL in CTimelinePanel.
    // Before editing this code, remove the block markers.
    event.Skip();
////@end wxEVT_SET_FOCUS event handler for ID_TIMELINE_PANEL in CTimelinePanel. 
}




/*!
 * Should we show tooltips?
 */

bool CTimelinePanel::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CTimelinePanel::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CTimelinePanel bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CTimelinePanel bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CTimelinePanel::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CTimelinePanel icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CTimelinePanel icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_TIMELINE_SEARCH
 */

void CTimelinePanel::OnButtonTimelineSearchClick( wxCommandEvent& event )
{
	wxBusyCursor bc;
    std::string sql = CSqlStrings::SelectForTimelinePane( m_StartDate->GetValueDT(), m_EndDate->GetValueDT(), m_ThresholdCtrl->GetValue() );
    FSDB::Database db = wxGetApp().GetDatabase();
    FSDB_CREATE_RS_READONLY_FWDONLY( db, rs );
    m_ListCtrl->DeleteAllItems();
    rs.Open( sql );
    int i = 0;
    m_ListCtrl->Freeze();
    while( !rs.IsEOF() ) {
    	m_ListCtrl->InsertItem( i, "" );

	    // this code is used to set the item's mask
	    wxListItem item;
	    item.SetId( i );
	    m_ListCtrl->GetItem( item );
	    item.SetMask( wxLIST_MASK_STATE|wxLIST_MASK_TEXT|wxLIST_MASK_DATA );
	    m_ListCtrl->SetItem( item );

		wxDateTime dt;
        wxString stmp;
        int col = 0;
        dt = rs["IMAGE_DATE"].GetAswxDateTime();
        stmp = dt.IsValid() ? dt.FormatDate() : "";
		m_ListCtrl->SetItem( i, col, stmp );
		col++;
        m_ListCtrl->SetItem( i, col, CUtils::long2string(rs["N_IMAGES"].GetAsLong()) );
		col++;

        i++;
        rs.MoveNext();
    }
    m_ListCtrl->Thaw();
    rs.Close();

    ResizeLCColumns();

    if( i == 0 ) {
        CUtils::MsgInfo( _("No images found") );
    }
}

void CTimelinePanel::CreateLCHeaders()
{
	wxListItem itemCol;
	int i = 0;

	itemCol.SetText( _("Date") );
	itemCol.SetAlign( wxLIST_FORMAT_LEFT );
	m_ListCtrl->InsertColumn( i++, itemCol );

	itemCol.SetText( _("Items") );
	itemCol.SetAlign( wxLIST_FORMAT_RIGHT );
	m_ListCtrl->InsertColumn( i++, itemCol );
}



/*!
 * wxEVT_COMMAND_LIST_ITEM_SELECTED event handler for wxID_ANY
 */

void CTimelinePanel::OnAnySelected( wxListEvent& event )
{
    // get the index of the selected
    int i = event.GetIndex();
    // get the date as text
    wxString sd = m_ListCtrl->GetItemText( i, 0 );
    // get it as a wxDateTime
    wxDateTime dt;
    dt.ParseFormat( sd, CUtils::GetDateFormatString() );

    GetMainFrame()->ShowTimelineData( dt );
}

void CTimelinePanel::ResizeLCColumns()
{
	int x, y;

    if( m_ListCtrl == NULL ) return;

	m_ListCtrl->GetClientSize( &x, &y );

	int w1 = x/2;
    w1 *= 1.2;  // enlarge by 20%
	int w2 = x - w1 - 2;

#ifndef __WXMSW__
    // Linux and Mac use the generic control: if a vertical scroll bar is shown GetClienteSize() still returns the same value
    // so I decided to always make the last column narrow enough to leave room for the scroll bar
    int delta = wxSystemSettings::GetMetric( wxSYS_VSCROLL_X ) + 5;
    int delta2 = delta / 2;
    w1 -= delta2;
    w2 -= (delta - delta2);
#endif

    m_ListCtrl->SetColumnWidth( 0, w1 );
	m_ListCtrl->SetColumnWidth( 1, w2 );
}



