/////////////////////////////////////////////////////////////////////////////
// Name:        timeline_panel.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     25/05/2012 08:25:57
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _TIMELINE_PANEL_H_
#define _TIMELINE_PANEL_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/datectrl.h"
#include "wx/dateevt.h"
#include "fswx/date_picker.h"
#include "wx/spinctrl.h"
#include "wx/listctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class CTimelinePanel;
class fsDatePickerCtrl;
class wxSpinCtrl;
class wxListCtrl;
////@end forward declarations

class CMainFrame;

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_TIMELINE_PANEL 10169
#define ID_BUTTON_TIMELINE_SEARCH 10170
#define SYMBOL_CTIMELINEPANEL_STYLE wxSUNKEN_BORDER|wxTAB_TRAVERSAL
#define SYMBOL_CTIMELINEPANEL_IDNAME ID_TIMELINE_PANEL
#define SYMBOL_CTIMELINEPANEL_SIZE wxDefaultSize
#define SYMBOL_CTIMELINEPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CTimelinePanel class declaration
 */

class CTimelinePanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CTimelinePanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CTimelinePanel();
    CTimelinePanel(wxWindow* parent, wxWindowID id = ID_TIMELINE_PANEL, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSUNKEN_BORDER|wxTAB_TRAVERSAL);

    /// Creation
    bool Create(wxWindow* parent, wxWindowID id = ID_TIMELINE_PANEL, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxSUNKEN_BORDER|wxTAB_TRAVERSAL);

    /// Destructor
    ~CTimelinePanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CTimelinePanel event handler declarations

    /// wxEVT_SET_FOCUS event handler for ID_TIMELINE_PANEL
    void OnSetFocus( wxFocusEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_TIMELINE_SEARCH
    void OnButtonTimelineSearchClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_LIST_ITEM_SELECTED event handler for wxID_ANY
    void OnAnySelected( wxListEvent& event );

////@end CTimelinePanel event handler declarations

////@begin CTimelinePanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CTimelinePanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CTimelinePanel member variables
    fsDatePickerCtrl* m_StartDate;
    fsDatePickerCtrl* m_EndDate;
    wxSpinCtrl* m_ThresholdCtrl;
    wxButton* m_SearchButton;
    wxListCtrl* m_ListCtrl;
////@end CTimelinePanel member variables

private:

	/// return a pointer to the main frame
	CMainFrame* GetMainFrame() { return (CMainFrame*) GetParent()->GetParent(); }

    // create the list control's headers
	void CreateLCHeaders();

    // resize the columns to a decent size
    void ResizeLCColumns();

};

#endif
    // _TIMELINE_PANEL_H_
