/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "uuidwrapper.h"

#ifdef __WXMAC__
#include <uuid/uuid.h>
#else
#include "uuid_sysdep.h"
#include "uuid.h"
#include <stdio.h>
#endif

CUUIDWrapper::CUUIDWrapper(void)
{
}

CUUIDWrapper::~CUUIDWrapper(void)
{
}

wxString CUUIDWrapper::ComputeUUID() {

#ifdef __WXMAC__
	// the OSX version uses an installed library
	uuid_t id;
	char s[50];

	uuid_generate( id );
	uuid_unparse_upper( id, s );

	return wxString( s, wxConvISO8859_1 );
#else
	// the other versions use custom source code
    uuid_t u;
	char s[50];
    int i;

	uuid_create(&u);

    sprintf( s, "%8.8x-%4.4x-%4.4x-%2.2x%2.2x-", u.time_low, u.time_mid,
    u.time_hi_and_version, u.clock_seq_hi_and_reserved,
    u.clock_seq_low );
    for( i = 0; i < 6; i++ )
        sprintf( s + 24 + i*2, "%2.2x", u.node[i] );

	return wxString( s, wxConvISO8859_1 );
#endif
}


